//+------------------------------------------------------------------+
//|                                                    MACD trad.mq4 |
//|                                                   David Louisson |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "David Louisson"
#property link      "http://www.metaquotes.net"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_color3  Blue
#property  indicator_width3  1
//---- indicator parameters
extern int FastEMA    = 12;
extern int SlowEMA    = 26;
extern int SignalSMA  = 9;
extern double HistogramScaling = 2;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexDrawBegin(0,SignalSMA);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//---- indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2) && !SetIndexBuffer(2,ind_buffer3))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"Histogram");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,MODE_SMA,i);
   for(i=0; i<limit; i++)
      ind_buffer3[i]=HistogramScaling*(ind_buffer1[i]-ind_buffer2[i]);
//    if (ind_buffer3[i]<0)  SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,3,Red);
//---- done
/*  ObjectDelete("Cmmt");
  ObjectCreate("Cmmt", OBJ_TEXT, 0, Time[15], Ask+(30*Point));
  ObjectSetText("Cmmt","ind_buffer1[i] = "+ind_buffer1[i],12,"Arial",Black);   
  ObjectSet("Cmmt", OBJPROP_TIMEFRAMES, OBJ_PERIOD_M15);
*/
   return(0);
  }